<template>
  <div>
    <el-card class="el-card">
      <el-form :model="filterQuery" class="query-form" size="mini" :inline="true">
        <el-form-item class="query-form-item" label="养护记录号:">
          <el-input v-model="filterQuery.orderId" placeholder="请输入养护记录号"
                    clearable="true"></el-input>
        </el-form-item>
        <el-form-item class="query-form-item" label="仓库:">
          <el-select v-model="filterQuery.invCode" placeholder="请选择仓库" clearable="true"
                     @change="invChange"
          >
            <el-option
              v-for="item in invList"
              :key="item.name"
              :label="item.name"
              :value="item.code">
              <span style="float: left">{{ item.name }}</span>
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item class="query-form-item" label="货位:">
          <el-select v-model="filterQuery.invSpaceCode" placeholder="请选择货位" clearable="true"
          >
            <el-option
              v-for="item in spaceList"
              :key="item.name"
              :label="item.name"
              :value="item.code">
              <span style="float: left">{{ item.name }}</span>
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item>
          <el-button-group style="margin-left: 10px;display:flex;">
            <el-button type="primary" icon="el-icon-refresh" @click="onReset">重置</el-button>
            <el-button type="primary" icon="el-icon-search" @click="onSubmit">查询</el-button>
            <el-button type="primary" icon="el-icon-plus" @click="addMAOrder">新增养护记录</el-button>
          </el-button-group>
        </el-form-item>
      </el-form>

      <el-table v-loading="loading" :data="list" style="width: 100%" highlight-current-row
                border>
        <el-table-column label="序号" type="index"></el-table-column>
        <el-table-column label="养护记录号" prop="orderId"></el-table-column>
        <el-table-column label="仓库" prop="invName"></el-table-column>
        <el-table-column label="货位" prop="invSpaceName"></el-table-column>
        <el-table-column label="养护日期" prop="createTime"></el-table-column>
        <el-table-column label="养护人" prop="createUserName"></el-table-column>
        <el-table-column label="状态" prop="status" show-overflow-tooltip width="120">
          <template slot-scope="scope">
            <el-tag>{{ statusMap[scope.row.status] }}</el-tag>
          </template>
        </el-table-column>
        <el-table-column label="操作">
          <template slot-scope="scope">
            <el-button
              type="text"
              size="small"
              @click.native.stop="editOrder(scope.row)"
            >编辑
            </el-button
            >
            <el-button
              type="text"
              size="small"
              @click.native.stop="submitAudit(scope.row)"
            >提交审核
            </el-button
            >
            <el-button
              type="text"
              size="small"
              @click.native.stop="deleteDialog(scope.row.id)"
            >删除
            </el-button
            >
          </template>
        </el-table-column>
      </el-table>
      <pagination
        v-show="total>0"
        :total="total"
        :limit.sync="filterQuery.limit"
        :page.sync="filterQuery.page"
        @pagination="getList"
      ></pagination>
    </el-card>

    <el-dialog
      :title="formMap[formName]"
      :visible.sync="formVisible"
      :close-on-click-modal="false"
      :close-on-press-escape="false"
      width="85%"
      v-if="formVisible"
    >
      <invMAOrderModify
        :maOrder="maOrder"
        :closeDialog="closeDialog"
      ></invMAOrderModify>
    </el-dialog>

  </div>
</template>

<script>
import {getInvListByUser} from "@/api/system/invWarehouse";
import {getInvSpaceList} from "@/api/inventory/invSpace";
import {getInvMAOrderList, deleteInvMAOrder, submitAudit} from "@/api/inventory/invMAOrder";
import invMAOrderModify from "@/views/inventory/InvMAOrderModify.vue";

export default {
  name: "InvMAOrderNew",
  data() {
    return {
      filterQuery: {
        orderId: null,
        invCode: this.$store.getters.locInvCode,
        invSpaceCode: null,
        status: 0,
        page: 1,
        limit: 20,
      },
      list: [],
      total: 0,
      invList: [],
      spaceList: [],
      loading: false,
      formVisible: false,
      codeTableLoading: false,
      statusMap: {
        0: "草稿",
        1: "未审核",
        2: "已审核"
      },
      formName: null,
      formMap: {
        add: "新增养护记录",
        edit: "编辑养护记录"
      },
      maOrder: {},
    };
  },
  methods: {
    onReset() {
      this.$router.push({
        path: "",
      });
      this.filterQuery = {
        orderId: null,
        invCode: this.$store.getters.locInvCode,
        invSpaceCode: null,
        status: 0,
        page: 1,
        limit: 20,
      };
      this.spaceList = [];
      this.getList();
      this.getInvList();
    },
    onSubmit() {
      this.filterQuery.page = 1;
      this.getList();
    },
    getList() {
      this.loading = true;
      getInvMAOrderList(this.filterQuery).then((res) => {
        this.loading = false;
        if (res.code === 20000) {
          this.list = res.data.list || [];
          this.total = res.data.total || 0;
        } else {
          this.$message.error(res.message);
          this.list = [];
          this.total = 0;
        }
      }).catch((error) => {
        this.loading = false;
        this.$message.error(error.message);
        this.list = [];
        this.total = 0;
      })
    },
    invChange() {
      this.spaceList = [];
      this.getSpaceList();
      this.getList();
    },
    getInvList() {
      getInvListByUser()
        .then((response) => {
          this.invList = response.data || [];
          this.getSpaceList();
          this.getList();
        })
        .catch(() => {
        });
    },
    getSpaceList() {
      let params = {invWarehouseCode: this.filterQuery.invCode, status: 1};
      getInvSpaceList(params).then((res) => {
        this.spaceList = res.data.list || [];
      })
    },
    addMAOrder() {
      this.formVisible = true;
      this.formName = 'add';
      this.maOrder = {};
    },
    editOrder(row) {
      this.formVisible = true;
      this.formName = 'edit';
      this.maOrder = row;
    },
    submitAudit(row) {
      let params = {id: row.id};
      submitAudit(params).then((res) => {
        if (res.code === 20000) {
          this.$message.success("提交成功！");
          this.getList();
        } else {
          this.$message.error(res.message);
        }
      }).catch((error) => {
        this.$message.error(error.message);
      });
    },
    deleteDialog(rowId) {
      this.$confirm('此操作将永久删除该养护记录, 是否继续?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        let params = {id: rowId};
        this.loading = true;
        deleteInvMAOrder(params).then((res) => {
          this.loading = false;
          if (res.code === 20000) {
            this.$message.success("删除成功！");
            this.getList();
          } else {
            this.$message.error(res.message);
          }
        }).catch(() => {
          this.loading = false;
        });
      });
    },
    closeDialog() {
      this.formVisible = false;
      this.getList();
    },
  },
  components: {
    invMAOrderModify
  },
  mounted() {
    document.body.ondrop = function (event) {
      event.preventDefault();
      event.stopPropagation();
    };
  },
  created() {
    this.getInvList();
  },
};
</script>

<style type="text/scss" lang="scss">
</style>

